package com.gic.haoban.manage.web.handle;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.enterprise.api.dto.security.DownloadReportDTO;
import com.gic.haoban.manage.web.utils.data.StoreAuthUtils;
import com.gic.haoban.manage.web.vo.wechatwork.WechatWorkLostStoreGroupVO;
import com.gic.web.common.download.DownloadHandlerAbstract;
import com.gic.web.common.download.context.Context;
import org.apache.commons.collections.CollectionUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;

/**
 * 数据-企微数据-流失好友
 */
@Component
public class WechatWorkLostStoreGroupHandle extends DownloadHandlerAbstract<WechatWorkLostStoreGroupVO> {

    private static final Logger LOGGER = LogManager.getLogger(WechatWorkLostStoreGroupHandle.class);

    @Autowired
    private StoreAuthUtils storeAuthUtils;

    @Override
    public List<WechatWorkLostStoreGroupVO> getData(Context context, String searchDataParams, Integer currentPage) {
        List<JSONObject> list = storeAuthUtils.getDataCommon(searchDataParams, currentPage,
                "数据-企微数据-流失好友导出日志进来", getPageSize(), false).getRows();
        if (CollectionUtils.isNotEmpty(list)) {
            List<WechatWorkLostStoreGroupVO> result = JSONObject.parseArray(JSON.toJSONString(list), WechatWorkLostStoreGroupVO.class);
            return result;
        }
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumnNames(Context context){
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("indexList");
        return list;
    }

    @Override
    public LinkedHashMap<String, List<String>> doubleColumnNames() {
        return null;
    }

    @Override
    public List<String> getColumns() {
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<String> getColumns(Context context) {
        DownloadReportDTO downloadReportDTO = context.getDownloadReportDTO();
        String searchDataParams = downloadReportDTO.getSearchDataParams();
        JSONObject jsonObject = JSONObject.parseObject(searchDataParams);
        List<String> list = (List<String>) jsonObject.get("fieldList");
        return list;
    }
}
